#ifndef PILA_HPP
#define PILA_HPP


using namespace std;

template <class T> class Pila {

private:

  struct node{
    T   info;
    node *seg;
  };

  int   alt;
  node *prim;



public:


//Constructoras
  Pila<T>(){
    prim = NULL;
    alt = 0;
  }

  Pila<T>(const Pila<T> &o){
  alt = o.alt;
  prim = copia(o.prim);
}


  Pila<T>& operator=(const Pila<T>& o){
  if (this!=&o){
    this->~Pila<T>();
    alt=o.alt;
    prim=copia(o.prim);
  }
  return *this;
}

  //Destructora
  ~Pila<T>(){
    esborra(prim);
  }


  //Modificadores

  void apilar(const T &x){
    node *aux = new node();
    aux->info = x;       //(*aux).info = x;
    aux->seg = prim;     //(*aux).seg = prim;
    prim = aux;
    ++alt;
  }
  
  void desapilar(){
    node *daux = prim;
    prim = prim->seg;     //prim = (*prim).seg;
    delete daux;
  }

  //Consultores

  T cim() const{
    return prim->info;    //return (*prim).info;
  }

  bool es_buida() const{
    return (prim == NULL);
  }

  int altura() const {
    return alt;
  }

  
private:

  static node* copia(node* m){
    if (!m) return NULL;
    else{
      node *aux = new node;
      aux->info=m->info;
      aux->seg=copia(m->seg);
      return aux;
    }
  }



  static void esborra(node* m){
    if (m!=NULL) {
      esborra(m->seg);
      delete(m);
    }
  }

};


#endif
