#include "PilaInt.hpp"
#include <iostream>

using namespace std;

//Constructoras
PilaInt::PilaInt(){
  prim = NULL;
  alt = 0;
}

void PilaInt::empilar(const int &x){
  node *aux = new node();
  aux->info = x;       //(*aux).info = x;
  aux->seg = prim;     //(*aux).seg = prim;
  prim = aux;
  ++alt;
}

void PilaInt::desempilar(){
  node *daux = prim;
  prim = prim->seg;     //prim = (*prim).seg;
  delete daux;
  --alt;
}

int PilaInt::cim() const{
  return prim->info;    //return (*prim).info;
}

bool PilaInt::es_buida() const{
  return (prim == NULL);
}

int PilaInt::mida() const {
  return alt;
}

//Destructora
PilaInt::~PilaInt(){
  node *aux = prim;
  while(aux!=NULL){
    node *daux = aux;
    aux = aux->seg;
    //cout << "deleting: " <<  daux->info << endl;
    delete daux;
  }
}

// PilaInt::~PilaInt(){
//   esborra(prim);
// }

// void PilaInt::esborra(PilaInt::node* m){
//   if (m!=NULL) {
//     esborra(m->seg);
//     delete(m);
//   }
// }


PilaInt::PilaInt(const PilaInt &o){
  alt = o.alt;
  prim = copia(o.prim);
}


PilaInt& PilaInt::operator=(const PilaInt& o){
  if (this!=&o){
    this->~PilaInt(); // esborra(prim);
    alt=o.alt;
    prim=copia(o.prim);
  }
  return *this;
}

PilaInt::node* PilaInt::copia(PilaInt::node* m){
  if (m==NULL) return NULL;
  else{
    node *aux = new node;
    aux->info=m->info;
    aux->seg=copia(m->seg);
    return aux;
  }
}

// PilaInt::node* PilaInt::copia(PilaInt::node* n){
//   if (!n) return NULL;
//   else{
//     node *aux = new node;
//     node *out = aux;
//     aux->info=n->info;
//     while (n->seg!=NULL) {
//       (*aux).seg = new node;
//        n=n->seg;
//        aux=aux->seg;
//        aux->info=n->info;
//     }
//     aux->seg=NULL;
//     return out;
//   }
// }


